Update customer details - Fabric

Update customer details

cURL

curl --request PUT \
  --url https://api.fabric.inc/v3/customers/{customerId} \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "name": {
    "title": "Dr.",
    "firstName": "Pat",
    "middleName": "E",
    "lastName": "Kake",
    "suffix": "Jr."
  },
  "emailAddress": "test@example.com",
  "phone": {
    "number": 15555551234,
    "type": "MOBILE"
  },
  "externalId": "1231012312-312-31231asda",
  "additionalAttributes": {
    "middleName": "user"
  }
}
'

Python

import requests

url = "https://api.fabric.inc/v3/customers/{customerId}"

payload = {
    "name": {
        "title": "Dr.",
        "firstName": "Pat",
        "middleName": "E",
        "lastName": "Kake",
        "suffix": "Jr."
    },
    "emailAddress": "test@example.com",
    "phone": {
        "number": 15555551234,
        "type": "MOBILE"
    },
    "externalId": "1231012312-312-31231asda",
    "additionalAttributes": { "middleName": "user" }
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)

JavaScript (Fetch)

const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    name: {
      title: 'Dr.',
      firstName: 'Pat',
      middleName: 'E',
      lastName: 'Kake',
      suffix: 'Jr.'
    },
    emailAddress: 'test@example.com',
    phone: {number: 15555551234, type: 'MOBILE'},
    externalId: '1231012312-312-31231asda',
    additionalAttributes: {middleName: 'user'}
  })
};

fetch('https://api.fabric.inc/v3/customers/{customerId}', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/customers/{customerId}",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "PUT",
  CURLOPT_POSTFIELDS => json_encode([
    'name' => [
        'title' => 'Dr.',
        'firstName' => 'Pat',
        'middleName' => 'E',
        'lastName' => 'Kake',
        'suffix' => 'Jr.'
    ],
    'emailAddress' => 'test@example.com',
    'phone' => [
        'number' => 15555551234,
        'type' => 'MOBILE'
    ],
    'externalId' => '1231012312-312-31231asda',
    'additionalAttributes' => [
        'middleName' => 'user'
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>

Response Codes

Example Response

{
  "id": "61df41892bf06d00092d0d8a",
  "name": {
    "firstName": "Pat",
    "lastName": "Doe",
    "title": "Dr.",
    "middleName": "E",
    "suffix": "Jr."
  },
  "emailAddress": "test@example.com",
  "isDeleted": false,
  "createdAt": "2023-08-30T23:20:42.822Z",
  "updatedAt": "2023-08-30T23:20:42.822Z",
  "status": "ACTIVE",
  "phone": {
    "number": 15555551234,
    "type": "MOBILE"
  },
  "externalId": "1231012312-312-31231asda",
  "additionalAttributes": {
    "middleName": "user"
  },
  "deletedAt": "2023-08-30T23:20:42.822Z",
  "defaultAddress": [
    {
      "id": "61604a30fdfacd0009816e44",
      "address": {
        "type": "BILLING",
        "addressLine1": "123 Main St.",
        "addressLine2": "Suite 100",
        "addressLine3": "Seventh floor",
        "addressLine4": "Attention: Pat E. Doe",
        "city": "Seattle",
        "region": "WA",
        "postalCode": 98121,
        "county": "King County",
        "country": "US",
        "latitude": 47.6205,
        "longitude": -122.3493
      },
      "isDeleted": false,
      "createdAt": "2023-08-30T23:20:42.822Z",
      "updatedAt": "2023-08-30T23:20:42.822Z",
      "additionalAttributes": {
        "landmark": "Beach"
      },
      "isDefault": false,
      "deletedAt": "2023-08-30T23:20:42.822Z"
    }
  ]
}

Error Responses

{
  "type": "INVALID_ACCOUNT_PROVIDED",
  "message": "Invalid account provided for the request."
}
{
  "type": "REQUEST_DENIED",
  "message": "Forbidden"
}
{
  "type": "CUSTOMER_NOT_FOUND",
  "message": "Data with the given identifier isn't found"
}
{
  "type": "INTERNAL_SERVER_ERROR",
  "message": "Internal server error"
}